local DescriptCfg = require("src/app/cfg/DescriptCfg")
FirstRecharge = class("FirstRecharge", function()
    return display.newLayer()
end)
function FirstRecharge:show(parent, id)
    Connect:sendMsg("ActivityFirstPayGiftAction", "openActivityFirstPayGift", { activityId = id },
            function(data)
                local layer = FirstRecharge.new(data.datas, id)
                parent:addChild(layer)
                NodeTranslator:transUp(layer, nil)
            end)
end
local TextInfos = {
    StringRes.activity_descript_22,
    StringRes.activity_descript_72,
    StringRes.already_attach,
}
local TextColors = {
    CommonColor.Red,
    CommonColor.Green,
    CommonColor.White,
}

function FirstRecharge:setAllItem(item_all, gift)
    --item:getChildByName("icon_item_4"):setVisible(false)
    item_all:getChildByName("text_title"):setString(gift.desc)
    item_all:getChildByName("gift_status"):setString(TextInfos[gift.status + 1])
    item_all:getChildByName("gift_status"):setColor(TextColors[gift.status + 1])
    local item = item_all:getChildByName("panel_first_recharge")
    for key, var in ipairs(gift.rewards) do
        local oneItem = item:getChildByName("icon_item_" .. key)
        local goodsInfo = StringUtil.getGoodsInfo(var.goodsId, var.goodsType)
        Common:changePic(oneItem, goodsInfo.icon)
        --将领不要那个圈圈
        if var.goodsType ~= 18 then
            Animation:playAnimation2(oneItem, gUIeffect[9].effect, 1.35)
        end
        oneItem:getChildByName("text_desc"):setString(var.desc)
    end
end

function FirstRecharge:ctor(data, activityId)
    self.myActivityId = activityId
    self.data = data
    self.Top = CCUILoader:load("res/csd/public/PanelBgLarge.csb")
    self:addChild(self.Top)

    self.Top:getChildByName("text_title"):setString(gActivity[self.myActivityId].name)
    --关闭
    local close = self.Top:getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:removeFromParent()
        end
    end)

    --新服关卡信息
    self.FirstRecharge = CCUILoader:load("res/csd/mainmap_left/activity_announcement/activity/first_recharge_reward/ui_first_recharge_reward_main.csb")
    self:addChild(self.FirstRecharge)

    self:init(self.data)
    ViewManager:OpenView(self)
end

--初始化页面
function FirstRecharge:init(data)
    self.data = data
    self.attachData = {}
    local pd = PlayerData:getInstanse()

    local list = self.FirstRecharge:getChildByName("panel_bg"):getChildByName("listview_recharge")

    local temp_item_all = list:getChildByName("panel_first_recharge_bg"):clone()
    list:removeAllItems()
    local waitApply = 0;
    local over = 0;
    local giftSize = 0
    for i, v in ipairs(self.data) do
        giftSize = i;
        local item_all = temp_item_all:clone()
        FirstRecharge:setAllItem(item_all, v)
        if v.status == 1 then
            waitApply = waitApply + 1
        elseif v.status == 2 then
            over = over + 1
        end
        if v.status == 1 and self.attachData.id == nil then
            self.attachData.id = v.giftId
            self.attachData.index = i
            self.attachData.price = v.price
        end
        list:pushBackCustomItem(item_all)
    end
    local btn = self.FirstRecharge:getChildByName("btn_recharge")
    --处理底部按钮
    --全部领取完了
    if giftSize == over then
        showShader:buttonToGray(btn)
        btn:setTitleText(StringRes.already_attach)
        Common:setBtnTouchEnable(btn, false)
    elseif waitApply ~= 0 then
        btn:setTitleText(StringRes.attach)
        Common:setBtnTouchEnable(btn, true)
    else
        btn:setTitleText(StringRes.recharge)
        Common:setBtnTouchEnable(btn, true)
    end
    btn:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if pd.basicData.firstPay == 0 or pd.basicData.firstPay == 2 then
                Recharge:show(gWorldScene)
            elseif pd.basicData.firstPay == 1 then
                if self.attachData.id then
                    local msg = { activityId = self.myActivityId, giftId = self.attachData.id }
                    Connect:sendMsg("ActivityFirstPayGiftAction", "buyActivityFirstPayGift", msg,
                            function(data)
                                FlyWordPrompt:prompt(string.format(StringRes.first_pay_gift_ok, self.attachData.price))
                                --刷新数据
                                self:init(data.datas)
                                --更新玩家信息
                                pd.basicData = data.info
                                pd.tanks = data.troops
                            end)
                end
            end
        end
    end)
end

return FirstRecharge