

local cjson = require("cjson")
local UserDefault = cc.UserDefault:getInstance()
local Scheduler = cc.Director:getInstance():getScheduler()
local GmShop = class("GmShop",function(scene)
    return PanelTabLayer.new(scene,{title=StringRes.text_gm_shop})
end)


--个人建议用table的方式,用if做判断次数会很多 ---hsm
--进入活动
function GmShop:enterActivity(id,time)
    local fca = require("src/app/views/activity/GmActivity.lua").new()
    fca:setActivityId(id)
    self:addChild(fca)
    
end

function GmShop:ctor(scene)
    self.page = cc.uiload:load("res/csd/mainmap_left/activity_announcement/ui_activity_accouncement_main.csb")
    self:addChild(self.page)
    self.activity = self.page:getChildByName("panel_pg"):getChildByName("listview_activity") -- 活动
    self.everydayActivity = self.page:getChildByName("panel_pg"):getChildByName("listview_daily_activity") --每日活动
    self.notice = self.page:getChildByName("panel_pg"):getChildByName("listview_announcement") --公告
    self.activity:setVisible(true)
    self.everydayActivity:setVisible(false)
    self.notice:setVisible(false)

    local pd = PlayerData:getInstanse()

    local function onNodeEvent(tag)
        if tag == "enter" then
            --活动通知
            local function registerActivity()
                Connect:register("notifyGmActivity",function(data)
                    NodeTranslator:deltaDo(1,function()
                        pd.openGmActivityTypes = data.activityVOs
                        self:freshActivity()
                    end)
                end)
            end
            registerActivity()

        elseif tag == "exit" then
            Connect:unregister("notifyActivity")
        end
    end
    self:registerScriptHandler(onNodeEvent)

    self:initTabs()

    ViewManager:OpenView(self)
end


function GmShop:ViewPage(page)
    if self.activity then self.activity:setVisible(false) end
    if self.everydayActivity then self.everydayActivity:setVisible(false) end
    if self.notice then self.notice:setVisible(false) end

    page:setVisible(true)
end

--获取活动列表
function GmShop:getActivityList()
    local pd = PlayerData:getInstanse()

    Connect:sendMsg("ActivityAction","openGmActivityList",nil,
        function(data)
            NodeTranslator:transUpBegin(self,nil)
            --更新数据
            pd.openGmActivityTypes = data.openActivityTypes
            self:freshActivity()
        end,false)
end


--刷新活动
function GmShop:freshActivity()
    self.activity:setVisible(true)
    local pd = PlayerData:getInstanse()
    self.activity:removeAllItems()

    local function setdata(var)
        local mode = self.page:getChildByName("panel_pg"):getChildByName("panel_activity"):clone()
        self.activity:pushBackCustomItem(mode)

        --图标
        local icon = mode:getChildByName("icon_activity")
        Common:changePic(icon,gActivity[var.type].icon)

        if gActivity[var.type].animatiaon == 1 then
            Animation:playAnimation(icon,gUIeffect[9].effect,true,15)
        else

        end
        
        
        local function getIsFirst(id)
            for key1, var1 in pairs(pd.getGametipsVO.activityStateVOs) do
                if var1.id == id then
        			if var1.state == 1 then
        				return true
        			else
        			    return false
        			end
        		end
        	end
        	return false
        end

        --提示数字
        local noticeNum = icon:getChildByName("icon_redpoint"):getChildByName("num_activity")
        noticeNum:setString(1)
        icon:getChildByName("icon_redpoint"):setVisible(false)
        --标题
        local title = mode:getChildByName("text_title")
        title:setString(gActivity[var.type].name)

        --时间
        local time = mode:getChildByName("text_time")
        if var.startTime == "-1" and var.endTime == "-1" then
            time:setString( StringRes.yongjiuyouxiao)
        else
            time:setString( var.startTime.."～"..var.endTime)
        end



        --状态（转圈）
        local btnGet = mode:getChildByName("btn_info")
        if var.activityState == 1 then
            Animation:playAnimation2(btnGet,gUIeffect[6].effect,1)
        else
            Animation:stopAnimation(btnGet,gUIeffect[6].effect)
        end

        --获取按钮
        local btnGet = mode:getChildByName("btn_get")
        btnGet:setVisible(false)

        --信息按钮
        local btnInfo = mode:getChildByName("btn_info")

        local function enter()
            self:enterActivity(var.type,var.startTime.."～"..var.endTime)
            --已读标志
            Common:setJsonData("ActivityList",var.type,1)
            Connect:sendMsg("ActivityAction","openOneActivity",{id = var.type},
                function(data)
                    --更新数据
                end,false)
            local function setId2(id)
                for key1, var1 in pairs(pd.getGametipsVO.activityStateVOs) do
                    if var1.id == id then
                        var1.state = 2
                    end
                end
            end
            setId2(var.type)
            self:freshActivity()
        end

        btnInfo:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                enter()
            end
        end)

        mode:addTouchEventListener(function(e, t)
            if t == ccui.TouchEventType.ended then MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                enter()
            end
        end)
    end

    local pd = PlayerData:getInstanse()
    printLog("tag","进来了")
    table.sort(pd.openGmActivityTypes,function(a,b)
        return gActivity[a.type].order < gActivity[b.type].order
        end)

    for key, var in pairs(pd.openGmActivityTypes) do
        setdata(var)
    end
end


function GmShop:initTabs()
    self:ViewPage(self.activity)
    self:getActivityList()
end

return GmShop