local TotalRechargeReward = class("TotalRechargeReward", function(scene, data)
    return CCUILoader:load("csd/mainmap_left/activity_announcement/activity/total_recharge_reward/ui_total_recharge_reward_main.csb")
end)

function TotalRechargeReward:show(parent, id)

    Connect:sendMsg("ActivityTotalPayAction", "openActivityTotalPay", { activityId = id },
            function(data)
                local layer = TotalRechargeReward.new(parent, data)
                layer.activityId = id
                parent:addChild(layer)
                NodeTranslator:transUp(layer, nil)
            end)
end

function TotalRechargeReward:ctor(parent, data)
    self.data = data
    self.maxPrice = 0
    self:initView()
end

function TotalRechargeReward:initView()
    self:getChildByName("panel_bg"):getChildByName("text_title"):setString(StringRes.activitydes_158)
    local close = self:getChildByName("panel_bg"):getChildByName("btn_close")
    close:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            self:close()
        end
    end)

    local panel_mask = self:getChildByName("panel_mask")
    self.panel_title_bg = panel_mask:getChildByName("panel_title_bg")
    --信息
    self.panel_title_bg:getChildByName("btn_info"):setVisible(false)
    self.panel_title_bg:getChildByName("text_time"):setString(StringRes.yongjiuyouxiao)
    self.panel_title_bg:getChildByName("text_desc_01"):setString(StringRes.tdes_158)
    self.panel_title_bg:getChildByName("text_desc_02"):setString(string.format(StringRes.tdes_158_1, self.data.totalMoney))

    self.panel_reward = panel_mask:getChildByName("panel_reward")
    self.listview_reward = self.panel_reward:getChildByName("listview_reward")
    self.btn_get = panel_mask:getChildByName("btn_get")
    showShader:buttonToGray(self.btn_get)
    self:updateItems(self.data)
    self.btn_get:addTouchEventListener(function(e, t)
        if t == ccui.TouchEventType.ended then
            MyAudio:PlayEffect(MusicAndEffect.btnEffect)
            if self.attachData.id then
                Connect:sendMsg("ActivityTotalPayAction", "buyActivityTotalPay", { giftId = self.attachData.id, activityId = self.activityId },
                        function(data)
                            FlyWordPrompt:prompt(string.format(StringRes.total_pay_gift_ok, self.attachData.price))
                            self:updateItems(data)
                            local pd = PlayerData:getInstanse()
                            --更新玩家信息
                            pd.basicData = data.info
                            pd.tanks = data.troops
                        end)
            end
        end
    end)
end

local TextInfos = {
    StringRes.activity_descript_22,
    StringRes.activity_descript_72,
    StringRes.already_attach,
}
local TextColors = {
    CommonColor.Red,
    CommonColor.Green,
    CommonColor.White,
}

function TotalRechargeReward:updateItems(data)
    self.data = data
    self.listview_reward:removeAllItems()
    self.attachData = {}

    table.sort(self.data.gifts, function(a, b)
        return a.price > b.price
    end)

    for i, v in ipairs(self.data.gifts) do
        if v.price > self.maxPrice then
            self.maxPrice = v.price
        end
        local item = self.panel_reward:getChildByName("panel_reward_bg"):clone()
        item:getChildByName("num_info"):setString(v.price)
        local text_info = item:getChildByName("text_info")
        printLog("giftId=" .. v.giftId .. "status=" .. v.status)
        text_info:setString(TextInfos[v.status + 1])
        text_info:setColor(TextColors[v.status + 1])
        item.textInfo = StringRes.exchange_get_reward
        for ii, vv in ipairs(v.rewards) do
            local tmpItem = item:getChildByName("icon_item_0" .. ii)
            local goodsInfo = StringUtil.getGoodsInfo(vv.goodsId, vv.goodsType)
            Common:changePic(tmpItem, goodsInfo.icon)
            tmpItem:getChildByName("num_desc"):setString("x" .. vv.goodsCount)
            tmpItem:addTouchEventListener(function(e, t)
                if t == ccui.TouchEventType.ended then
                    MyAudio:PlayEffect(MusicAndEffect.btnEffect)
                    FlyWordPrompt:prompt(vv.desc)
                end
            end)
            end
            if v.status == 1 and self.attachData.id == nil then
        self.attachData.id = v.giftId
        self.attachData.textInfo = item.textInfo
        self.attachData.index = i
            self.attachData.price = v.price
            end
            self.listview_reward:pushBackCustomItem(item)
        end
        self.panel_reward:getChildByName("progress_bg"):getChildByName("progressbar"):setPercent(self.data.totalMoney / self.maxPrice * 100)
        Common:setBtnTouchEnable(self.btn_get, self.attachData.id ~= nil)
    end

    function TotalRechargeReward:close()
        NodeTranslator:transDown(self, function()
            self:getParent():getActivityList()
            self:removeFromParent()
        end)
    end

    return TotalRechargeReward